=== modified file 'plugin/memcached_stats/analysis_table.cc'
--- plugin/memcached_stats/analysis_table.cc	2009-10-01 23:33:54 +0000
+++ plugin/memcached_stats/analysis_table.cc	2009-10-02 02:15:04 +0000
@@ -57,13 +57,13 @@
   memcached_server_push(serv, tmp_serv);
   memcached_server_list_free(tmp_serv);
   memcached_stat_st *stats= memcached_stat(serv, NULL, &rc);
-  memcached_analysis_st *report= memcached_analyze(serv, stats, &rc);
   memcached_server_st *servers= memcached_server_list(serv);
 
   uint32_t server_count= memcached_server_count(serv);
 
   if (server_count > 1)
   {
+    memcached_analysis_st *report= memcached_analyze(serv, stats, &rc);
     table->restoreRecordAsDefault();
 
     table->field[0]->store(server_count);
@@ -91,9 +91,9 @@
     {
       return 1;
     }
+    free(report);
   }
 
-  free(report);
   memcached_stat_free(serv, stats);
   memcached_free(serv);
   return 0;

=== modified file 'plugin/memcached_stats/plugin.ini'
--- plugin/memcached_stats/plugin.ini	2009-10-01 20:06:51 +0000
+++ plugin/memcached_stats/plugin.ini	2009-10-02 02:15:04 +0000
@@ -7,3 +7,4 @@
 sources=memcached_stats.cc stats_table.cc analysis_table.cc
 build_conditional="${ac_cv_libmemcached}" = "yes"
 ldflags=${LTLIBMEMCACHED}
+testsuite=memcached_stats

=== added directory 'tests/suite/memcached_stats'
=== added directory 'tests/suite/memcached_stats/r'
=== added file 'tests/suite/memcached_stats/r/describe.result'
--- tests/suite/memcached_stats/r/describe.result	1970-01-01 00:00:00 +0000
+++ tests/suite/memcached_stats/r/describe.result	2009-10-02 02:15:04 +0000
@@ -0,0 +1,43 @@
+select table_name
+from information_schema.tables
+where table_name like '%memcached%';
+table_name
+MEMCACHED_STATS
+MEMCACHED_ANALYSIS
+desc information_schema.memcached_stats;
+Field	Type	Null	Key	Default	Extra
+NAME	varchar(32)	NO			
+PORT_NUMBER	bigint	NO		0	
+PROCESS_ID	bigint	NO		0	
+UPTIME	bigint	NO		0	
+TIME	bigint	NO		0	
+VERSION	varchar(8)	NO			
+POINTER_SIZE	bigint	NO		0	
+RUSAGE_USER	bigint	NO		0	
+RUSAGE_SYSTEM	bigint	NO		0	
+CURRENT_ITEMS	bigint	NO		0	
+TOTAL_ITEMS	bigint	NO		0	
+BYTES	bigint	NO		0	
+CURRENT_CONNECTIONS	bigint	NO		0	
+TOTAL_CONNECTIONS	bigint	NO		0	
+CONNECTION_STRUCTURES	bigint	NO		0	
+GETS	bigint	NO		0	
+SETS	bigint	NO		0	
+HITS	bigint	NO		0	
+MISSES	bigint	NO		0	
+EVICTIONS	bigint	NO		0	
+BYTES_READ	bigint	NO		0	
+BYTES_WRITTEN	bigint	NO		0	
+LIMIT_MAXBYTES	bigint	NO		0	
+THREADS	bigint	NO		0	
+desc information_schema.memcached_analysis;
+Field	Type	Null	Key	Default	Extra
+SERVERS_ANALYZED	bigint	NO		0	
+AVERAGE_ITEM_SIZE	bigint	NO		0	
+NODE_WITH_MOST_MEM_CONSUMPTION	varchar(32)	NO			
+USED_BYTES	bigint	NO		0	
+NODE_WITH_LEAST_FREE_SPACE	varchar(32)	NO			
+FREE_BYTES	bigint	NO		0	
+NODE_WITH_LONGEST_UPTIME	varchar(32)	NO			
+LONGEST_UPTIME	bigint	NO		0	
+POOL_WIDE_HIT_RATIO	bigint	NO		0	

=== added file 'tests/suite/memcached_stats/r/query.result'
--- tests/suite/memcached_stats/r/query.result	1970-01-01 00:00:00 +0000
+++ tests/suite/memcached_stats/r/query.result	2009-10-02 02:15:04 +0000
@@ -0,0 +1,17 @@
+select * 
+from information_schema.memcached_stats;
+NAME	PORT_NUMBER	PROCESS_ID	UPTIME	TIME	VERSION	POINTER_SIZE	RUSAGE_USER	RUSAGE_SYSTEM	CURRENT_ITEMS	TOTAL_ITEMS	BYTES	CURRENT_CONNECTIONS	TOTAL_CONNECTIONS	CONNECTION_STRUCTURES	GETS	SETS	HITS	MISSES	EVICTIONS	BYTES_READ	BYTES_WRITTEN	LIMIT_MAXBYTES	THREADS
+select *
+from information_schema.memcached_analysis;
+SERVERS_ANALYZED	AVERAGE_ITEM_SIZE	NODE_WITH_MOST_MEM_CONSUMPTION	USED_BYTES	NODE_WITH_LEAST_FREE_SPACE	FREE_BYTES	NODE_WITH_LONGEST_UPTIME	LONGEST_UPTIME	POOL_WIDE_HIT_RATIO
+select variable_name, variable_value
+from information_schema.global_variables
+where variable_name = 'memcached_stats_servers';
+variable_name	variable_value
+MEMCACHED_STATS_SERVERS	
+set global memcached_stats_servers = 'localhost:11211';
+select variable_name, variable_value
+from information_schema.global_variables
+where variable_name = 'memcached_stats_servers';
+variable_name	variable_value
+MEMCACHED_STATS_SERVERS	localhost:11211

=== added directory 'tests/suite/memcached_stats/t'
=== added file 'tests/suite/memcached_stats/t/describe.test'
--- tests/suite/memcached_stats/t/describe.test	1970-01-01 00:00:00 +0000
+++ tests/suite/memcached_stats/t/describe.test	2009-10-02 02:15:04 +0000
@@ -0,0 +1,14 @@
+#
+# Make sure our tables are actually present!
+#
+select table_name
+from information_schema.tables
+where table_name like '%memcached%';
+
+#
+# verify the structure of these I_S tables.
+#
+
+desc information_schema.memcached_stats;
+
+desc information_schema.memcached_analysis;

=== added file 'tests/suite/memcached_stats/t/query.test'
--- tests/suite/memcached_stats/t/query.test	1970-01-01 00:00:00 +0000
+++ tests/suite/memcached_stats/t/query.test	2009-10-02 02:15:04 +0000
@@ -0,0 +1,36 @@
+#
+# perform a query on the memcached I_S statistics tables before the
+# memcached related system variable has been set. Both of these queries
+# should return 0 rows
+#
+
+select * 
+from information_schema.memcached_stats;
+
+select *
+from information_schema.memcached_analysis;
+
+#
+# Look at the current value of the memcached related system variable
+#
+select variable_name, variable_value
+from information_schema.global_variables
+where variable_name = 'memcached_stats_servers';
+
+#
+# Now try setting it to a certain value
+#
+set global memcached_stats_servers = 'localhost:11211';
+
+#
+# make sure the system variable has been updated
+#
+select variable_name, variable_value
+from information_schema.global_variables
+where variable_name = 'memcached_stats_servers';
+
+#
+# Once the ability to created an embedded server has been added to
+# memcached, we will actually start up an embedded server and perform some
+# queries on it here...
+#

